import { $x, $y, $z, defn, mul, ret, sym, vec2, vec3 } from "@thi.ng/shader-ast";
import { cossin } from "./sincos";
/**
 * Converts 2D polar vector `v` to cartesian coordinates. See `polar2()`
 * for reverse operation.
 *
 * @param v
 */
export const cartesian2 = (v) => mul(cossin($y(v)), vec2($x(v)));
/**
 * Converts 3D polar vector `v` to cartesian coordinates. See `polar3()`
 * for reverse operation.
 *
 * @param v
 */
export const cartesian3 = defn("vec3", "cartesian3", [["vec3"]], (v) => {
    let r;
    let t;
    let p;
    return [
        (r = sym($x(v))),
        (t = sym(cossin($y(v)))),
        (p = sym(cossin($z(v)))),
        ret(vec3(mul(mul(r, $x(t)), $x(p))))
    ];
});
