import { clamp, float, FLOAT0, FLOAT1, vec2, vec3, vec4 } from "@thi.ng/shader-ast";
/**
 * Inline function, expands to equivalent of `clamp(x, 0, 1)`.
 *
 * @param x
 */
export const clamp01 = (x) => ((x.type === "float"
    ? clamp(x, FLOAT0, FLOAT1)
    : x.type === "vec2"
        ? clamp(x, vec2(), vec2(1))
        : x.type === "vec3"
            ? clamp(x, vec3(), vec3(1))
            : clamp(x, vec4(), vec4(1))));
/**
 * Inline function, expands to equivalent of `clamp(x, -1, 1)`.
 *
 * @param x
 */
export const clamp11 = (x) => ((x.type === "float"
    ? clamp(x, float(-1), FLOAT1)
    : x.type === "vec2"
        ? clamp(x, vec2(-1), vec2(1))
        : x.type === "vec3"
            ? clamp(x, vec3(-1), vec3(1))
            : clamp(x, vec4(-1), vec4(1))));
