import { $x, $y, mul, sub } from "@thi.ng/shader-ast";
/**
 * Inline function. Computes 2D cross product of given vectors.
 *
 * @see crossC2
 *
 * @param a
 * @param b
 */
export const cross2 = (a, b) => crossC2($x(a), $y(a), $x(b), $y(b));
/**
 * Inline function. Computes 2D cross product of given individual
 * components: ax * by - ay * bx
 *
 * @param ax
 * @param ay
 * @param bx
 * @param by
 */
export const crossC2 = (ax, ay, bx, by) => sub(mul(ax, by), mul(ay, bx));
