import { Op2, Prim, Term } from "@thi.ng/shader-ast";
/**
 * Inline function. Fits value `a` in [0..1] interval to new interval
 * [b..c]. No clamping performed. Same as `mix(b, c, a)`
 *
 * @param a
 * @param b
 * @param c
 */
export declare const fit01: <A extends Prim, B extends A, C extends B>(a: Term<A>, b: Term<B>, c: Term<C>) => import("@thi.ng/shader-ast").FnCall<A>;
/**
 * Inline function. Fits value `x` in [-1..+1] interval to [0..1]
 * interval. No clamping performed.
 *
 * @param x
 */
export declare const fit1101: <T extends Prim>(x: Term<T>) => Op2<T>;
/**
 * Inline function. Fits value `x` in [0..1] interval to [-1..+1]
 * interval. No clamping performed.
 *
 * @param x
 */
export declare const fit0111: <T extends Prim>(x: Term<T>) => Op2<T>;
