import { add, FLOAT05, FLOAT1, FLOAT2, mix, mul, sub } from "@thi.ng/shader-ast";
/**
 * Inline function. Fits value `a` in [0..1] interval to new interval
 * [b..c]. No clamping performed. Same as `mix(b, c, a)`
 *
 * @param a
 * @param b
 * @param c
 */
export const fit01 = (a, b, c) => mix(b, c, a);
/**
 * Inline function. Fits value `x` in [-1..+1] interval to [0..1]
 * interval. No clamping performed.
 *
 * @param x
 */
export const fit1101 = (x) => add(mul(x, FLOAT05), FLOAT05);
/**
 * Inline function. Fits value `x` in [0..1] interval to [-1..+1]
 * interval. No clamping performed.
 *
 * @param x
 */
export const fit0111 = (x) => sub(mul(x, FLOAT2), FLOAT1);
