import { $w, $x, $y, $z, max } from "@thi.ng/shader-ast";
/**
 * Inline function. Returns max(v.x, v.y)
 *
 * @param v
 */
export const maxComp2 = (v) => max($x(v), $y(v));
/**
 * Inline function. Returns max(v.x, v.y, v.z)
 *
 * @param v
 */
export const maxComp3 = (v) => max(maxComp2(v), $z(v));
/**
 * Inline function. Returns max(v.x, v.y, v.z, v.w)
 *
 * @param v
 */
export const maxComp4 = (v) => max(maxComp3(v), $w(v));
