/**
 * iq's hash PRNG producing 2D results.
 *
 * @param p
 */
export declare const hash2: import("@thi.ng/shader-ast").TaggedFn1<"vec2", "vec2">;
/**
 * iq's hash PRNG producing 3D results.
 *
 * @param p
 */
export declare const hash3: import("@thi.ng/shader-ast").TaggedFn1<"vec2", "vec3">;
/**
 * 1D hash.
 *
 * Dave Hoskins (https://www.shadertoy.com/view/4djSRW)
 *
 * @param p
 */
export declare const hash11: import("@thi.ng/shader-ast").TaggedFn1<"float", "float">;
/**
 * 2D -> 1D hash.
 *
 * Dave Hoskins (https://www.shadertoy.com/view/4djSRW)
 *
 * @param p
 */
export declare const hash12: import("@thi.ng/shader-ast").TaggedFn1<"vec2", "float">;
/**
 * 3D -> 1D hash.
 *
 * Dave Hoskins (https://www.shadertoy.com/view/4djSRW)
 *
 * @param p
 */
export declare const hash13: import("@thi.ng/shader-ast").TaggedFn1<"vec3", "float">;
/**
 * 1D -> 2D hash.
 *
 * Dave Hoskins (https://www.shadertoy.com/view/4djSRW)
 *
 * @param p
 */
export declare const hash21: import("@thi.ng/shader-ast").TaggedFn1<"float", "vec2">;
/**
 * 2D -> 2D hash.
 *
 * Dave Hoskins (https://www.shadertoy.com/view/4djSRW)
 *
 * @param p
 */
export declare const hash22: import("@thi.ng/shader-ast").TaggedFn1<"vec2", "vec2">;
/**
 * 3D -> 2D hash.
 *
 * Dave Hoskins (https://www.shadertoy.com/view/4djSRW)
 *
 * @param p
 */
export declare const hash23: import("@thi.ng/shader-ast").TaggedFn1<"vec3", "vec2">;
/**
 * 1D -> 3D hash.
 *
 * Dave Hoskins (https://www.shadertoy.com/view/4djSRW)
 *
 * @param p
 */
export declare const hash31: import("@thi.ng/shader-ast").TaggedFn1<"float", "vec3">;
/**
 * 2D -> 3D hash.
 *
 * Dave Hoskins (https://www.shadertoy.com/view/4djSRW)
 *
 * @param p
 */
export declare const hash32: import("@thi.ng/shader-ast").TaggedFn1<"vec2", "vec3">;
/**
 * 3D -> 3D hash.
 *
 * Dave Hoskins (https://www.shadertoy.com/view/4djSRW)
 *
 * @param p
 */
export declare const hash33: import("@thi.ng/shader-ast").TaggedFn1<"vec3", "vec3">;
/**
 * 1D -> 4D hash.
 *
 * Dave Hoskins (https://www.shadertoy.com/view/4djSRW)
 *
 * @param p
 */
export declare const hash41: import("@thi.ng/shader-ast").TaggedFn1<"float", "vec4">;
/**
 * 2D -> 4D hash.
 *
 * Dave Hoskins (https://www.shadertoy.com/view/4djSRW)
 *
 * @param p
 */
export declare const hash42: import("@thi.ng/shader-ast").TaggedFn1<"vec2", "vec4">;
/**
 * 3D -> 4D hash.
 *
 * Dave Hoskins (https://www.shadertoy.com/view/4djSRW)
 *
 * @param p
 */
export declare const hash43: import("@thi.ng/shader-ast").TaggedFn1<"vec3", "vec4">;
/**
 * 4D -> 4D hash.
 *
 * Dave Hoskins (https://www.shadertoy.com/view/4djSRW)
 *
 * @param p
 */
export declare const hash44: import("@thi.ng/shader-ast").TaggedFn1<"vec4", "vec4">;
