/**
 * IQ's parametric 2D voronoise. Depending on `u` and `v`, this function
 * produces 4 different noise types
 *
 * - cell noise (0,0)
 * - voronoi (1,0)
 * - perlin noise (0,1)
 * - voronoise (1,1)
 *
 * http://www.iquilezles.org/www/articles/voronoise/voronoise.htm
 *
 * Note: This implementation uses the improved `hash32` by Dave Hoskins
 * instead of iq's original `hash3`.
 *
 * @param p
 * @param u
 * @param v
 */
export declare const voronoise2: import("@thi.ng/shader-ast").TaggedFn3<"vec2", "float", "float", "float">;
