export declare const worleyDist: import("@thi.ng/shader-ast").TaggedFn2<"vec3", "vec3", "vec3">;
export declare const worleyDistManhattan: import("@thi.ng/shader-ast").TaggedFn2<"vec3", "vec3", "vec3">;
/**
 * Higher order function. Computes 2D Worley noise using provided
 * distance function. The returned function takes 2 args: position and
 * jitter amount, the latter in [0..1] interval. Returns noise
 * components as vec2, with the x component containing the distance from
 * closest simplex center and y the noise value. The vector components
 * can be used individually or combined (e.g. `noise.y - noise.x`)...
 *
 * Based on implementation by Stefan Gustavson:
 * http://webstaff.itn.liu.se/~stegu/GLSL-cellular/GLSL-cellular-notes.pdf
 *
 * @param distFn
 */
export declare const worley2: (distFn: import("@thi.ng/api").Fn2<import("@thi.ng/shader-ast").Term<"vec3">, import("@thi.ng/shader-ast").Term<"vec3">, import("@thi.ng/shader-ast").FnCall<"vec3">>) => import("@thi.ng/shader-ast").TaggedFn2<"vec2", "float", "vec2">;
