import { $, $x, add, defn, normalize, ret, sub, sym, vec2, vec3 } from "@thi.ng/shader-ast";
/**
 * Higher order function producing a function to compute the raymarched
 * scene normal for a given scene function and intersection position.
 * Like `raymarch()`, this function takes an existing scene function as
 * argument.
 *
 * @param scene
 * @param name
 */
export const raymarchNormal = (scene, name = "raymarchNormal") => defn("vec3", name, [["vec3"], ["float"]], (p, smooth) => {
    let dn;
    const comp = (id) => sub($x(scene(add(p, $(dn, id)))), $x(scene(sub(p, $(dn, id)))));
    return [
        (dn = sym(vec2(smooth, 0))),
        ret(normalize(vec3(comp("xyy"), comp("yxy"), comp("yyx"))))
    ];
});
