import { RaymarchOpts } from "../api";
/**
 * Higher order function producing a function to perform a raymarch
 * using the provided `scene` function and options to configure the
 * raymarch process itself.
 *
 * Returns an AST function which takes 2 args: ray origin, normalized
 * ray direction and returning a 2D vector of:
 *
 * - x = the signed distance to the `scene` defined SDF surface
 * - y = user data provided by `scene` (e.g. material ID)
 *
 * The `scene` function itself takes a 3D point as input and returns a
 * vec2 with the same component meaning as above.
 *
 * @param scene
 * @param _opts
 */
export declare const raymarchScene: (scene: import("@thi.ng/shader-ast").TaggedFn1<"vec3", "vec2">, _opts?: Partial<RaymarchOpts> | undefined) => import("@thi.ng/shader-ast").TaggedFn2<"vec3", "vec3", "vec2">;
