import { $x, $y, div, madd, modi, uvec2 } from "@thi.ng/shader-ast";
/**
 * Inline function. Similar to `indexToUV()`, but returns uvec2 in pixel
 * coords. Not compatible with WebGL1.
 *
 * @param i
 * @param width
 */
export const indexToCoord = (i, width) => uvec2(modi(i, width), div(i, width));
/**
 * Inline function. Reverse op to `indexToCoord()`.  Not compatible with
 * WebGL1.
 *
 * @param coord
 * @param width
 */
export const coordToIndex = (coord, width) => madd($y(coord), width, $x(coord));
