/**
 * Inline function. Returns x component at index `i` in `tex`.
 *
 * @param tex
 * @param i
 * @param size
 */
export declare const readIndex1: (tex: import("@thi.ng/shader-ast").Term<"sampler2D">, i: import("@thi.ng/shader-ast").Term<"int">, size: import("@thi.ng/shader-ast").Term<"ivec2">) => import("@thi.ng/shader-ast").Swizzle<"float">;
/**
 * Inline function. Returns vec2 (x,y components) at index `i` in `tex`.
 *
 * @param tex
 * @param i
 * @param size
 */
export declare const readIndex2: (tex: import("@thi.ng/shader-ast").Term<"sampler2D">, i: import("@thi.ng/shader-ast").Term<"int">, size: import("@thi.ng/shader-ast").Term<"ivec2">) => import("@thi.ng/shader-ast").Swizzle<"vec2">;
/**
 * Inline function. Returns vec3 (x,y,z components) at index `i` in `tex`.
 *
 * @param tex
 * @param i
 * @param size
 */
export declare const readIndex3: (tex: import("@thi.ng/shader-ast").Term<"sampler2D">, i: import("@thi.ng/shader-ast").Term<"int">, size: import("@thi.ng/shader-ast").Term<"ivec2">) => import("@thi.ng/shader-ast").Swizzle<"vec3">;
/**
 * Inline function. Returns vec4 at index `i` in `tex`.
 *
 * @param tex
 * @param i
 * @param size
 */
export declare const readIndex4: (tex: import("@thi.ng/shader-ast").Term<"sampler2D">, i: import("@thi.ng/shader-ast").Term<"int">, size: import("@thi.ng/shader-ast").Term<"ivec2">) => import("@thi.ng/shader-ast").FnCall<"vec4">;
